VTK: vtkUnstructuredGridVolumeRayIntegrator Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkUnstructuredGridVolumeRayIntegrator Class Referenceabstract

a superclass for volume ray integration functions More...

`#include <vtkUnstructuredGridVolumeRayIntegrator.h>`

Inheritance diagram for vtkUnstructuredGridVolumeRayIntegrator:
[legend]
Collaboration diagram for vtkUnstructuredGridVolumeRayIntegrator:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkUnstructuredGridVolumeRayIntegrator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | Initialize (vtkVolume *volume, vtkDataArray *scalars)=0
| Set up the integrator with the given properties and scalars. More...
virtual void | Integrate (vtkDoubleArray *intersectionLengths, vtkDataArray *nearIntersections, vtkDataArray *farIntersections, float color[4])=0
| Given a set of intersections (defined by the three arrays), compute the piecewise integration of the array in front to back order. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkUnstructuredGridVolumeRayIntegrator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkUnstructuredGridVolumeRayIntegrator ()
| ~vtkUnstructuredGridVolumeRayIntegrator () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

a superclass for volume ray integration functions

vtkUnstructuredGridVolumeRayIntegrator is a superclass for ray integration functions that can be used within a vtkUnstructuredGridVolumeRayCastMapper.

See also
  vtkUnstructuredGridVolumeRayCastMapper vtkUnstructuredGridVolumeRayCastFunction

Definition at line 41 of file vtkUnstructuredGridVolumeRayIntegrator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkUnstructuredGridVolumeRayIntegrator::Superclass

Definition at line 44 of file vtkUnstructuredGridVolumeRayIntegrator.h.

## Constructor & Destructor Documentation

## ◆ vtkUnstructuredGridVolumeRayIntegrator()

vtkUnstructuredGridVolumeRayIntegrator::vtkUnstructuredGridVolumeRayIntegrator | ( |  | ) |
| protected

## ◆ ~vtkUnstructuredGridVolumeRayIntegrator()

vtkUnstructuredGridVolumeRayIntegrator::~vtkUnstructuredGridVolumeRayIntegrator | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkUnstructuredGridVolumeRayIntegrator::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkUnstructuredGridVolumeRayIntegrator::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkUnstructuredGridLinearRayIntegrator, vtkUnstructuredGridPartialPreIntegration, vtkUnstructuredGridPreIntegration, and vtkUnstructuredGridHomogeneousRayIntegrator.

## ◆ SafeDownCast()

static vtkUnstructuredGridVolumeRayIntegrator* vtkUnstructuredGridVolumeRayIntegrator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkUnstructuredGridVolumeRayIntegrator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkUnstructuredGridLinearRayIntegrator, vtkUnstructuredGridPartialPreIntegration, vtkUnstructuredGridPreIntegration, and vtkUnstructuredGridHomogeneousRayIntegrator.

## ◆ NewInstance()

vtkUnstructuredGridVolumeRayIntegrator* vtkUnstructuredGridVolumeRayIntegrator::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkUnstructuredGridVolumeRayIntegrator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Initialize()

virtual void vtkUnstructuredGridVolumeRayIntegrator::Initialize | ( | vtkVolume * | volume,
|  | vtkDataArray * | scalars
| ) |  |
| pure virtual

Set up the integrator with the given properties and scalars.

Implemented in vtkUnstructuredGridLinearRayIntegrator, vtkUnstructuredGridPartialPreIntegration, vtkUnstructuredGridPreIntegration, and vtkUnstructuredGridHomogeneousRayIntegrator.

## ◆ Integrate()

virtual void vtkUnstructuredGridVolumeRayIntegrator::Integrate | ( | vtkDoubleArray * | intersectionLengths,
|  | vtkDataArray * | nearIntersections,
|  | vtkDataArray * | farIntersections,
|  | float | color[4]
| ) |  |
| pure virtual

Given a set of intersections (defined by the three arrays), compute the piecewise integration of the array in front to back order.

/c intersectionLengths holds the lengths of each piecewise segment. /c nearIntersections and /c farIntersections hold the scalar values at the front and back of each segment. /c color should contain the RGBA value of the volume in front of the segments passed in, and the result will be placed back into /c color.

Implemented in vtkUnstructuredGridLinearRayIntegrator, vtkUnstructuredGridPartialPreIntegration, vtkUnstructuredGridPreIntegration, and vtkUnstructuredGridHomogeneousRayIntegrator.

The documentation for this class was generated from the following file:

- Rendering/Volume/vtkUnstructuredGridVolumeRayIntegrator.h